// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module mul_add (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        x_V,
        y_V,
        z_V,
        ap_return
);

parameter    ap_const_logic_1 = 1'b1;
parameter    ap_const_logic_0 = 1'b0;
parameter    ap_ST_st1_fsm_0 = 3'b000;
parameter    ap_ST_st2_fsm_1 = 3'b1;
parameter    ap_ST_st3_fsm_2 = 3'b10;
parameter    ap_ST_st4_fsm_3 = 3'b11;
parameter    ap_ST_st5_fsm_4 = 3'b100;
parameter    ap_ST_st6_fsm_5 = 3'b101;
parameter    ap_ST_st7_fsm_6 = 3'b110;
parameter    ap_true = 1'b1;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [8:0] x_V;
input  [21:0] y_V;
input  [31:0] z_V;
output  [31:0] ap_return;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg   [2:0] ap_CS_fsm = 3'b000;
wire   [30:0] grp_fu_41_p2;
reg   [30:0] tmp_2_reg_76;
wire   [24:0] tmp_1_cast_fu_37_p0;
wire   [24:0] grp_fu_41_p0;
wire   [8:0] grp_fu_41_p1;
wire   [31:0] tmp_2_cast_fu_47_p1;
wire    grp_fu_41_ce;
reg   [2:0] ap_NS_fsm;
wire   [30:0] grp_fu_41_p00;
wire   [30:0] grp_fu_41_p10;


date2time_mul_25ns_9ns_31_5 #(
    .ID( 1 ),
    .NUM_STAGE( 5 ),
    .din0_WIDTH( 25 ),
    .din1_WIDTH( 9 ),
    .dout_WIDTH( 31 ))
date2time_mul_25ns_9ns_31_5_U1(
    .clk( ap_clk ),
    .reset( ap_rst ),
    .din0( grp_fu_41_p0 ),
    .din1( grp_fu_41_p1 ),
    .ce( grp_fu_41_ce ),
    .dout( grp_fu_41_p2 )
);



/// the current state (ap_CS_fsm) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_ap_CS_fsm
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_st1_fsm_0;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if ((ap_ST_st6_fsm_5 == ap_CS_fsm)) begin
        tmp_2_reg_76 <= grp_fu_41_p2;
    end
end

/// ap_done assign process. ///
always @ (ap_start or ap_CS_fsm)
begin
    if (((~(ap_const_logic_1 == ap_start) & (ap_ST_st1_fsm_0 == ap_CS_fsm)) | (ap_ST_st7_fsm_6 == ap_CS_fsm))) begin
        ap_done = ap_const_logic_1;
    end else begin
        ap_done = ap_const_logic_0;
    end
end

/// ap_idle assign process. ///
always @ (ap_start or ap_CS_fsm)
begin
    if ((~(ap_const_logic_1 == ap_start) & (ap_ST_st1_fsm_0 == ap_CS_fsm))) begin
        ap_idle = ap_const_logic_1;
    end else begin
        ap_idle = ap_const_logic_0;
    end
end

/// ap_ready assign process. ///
always @ (ap_CS_fsm)
begin
    if ((ap_ST_st7_fsm_6 == ap_CS_fsm)) begin
        ap_ready = ap_const_logic_1;
    end else begin
        ap_ready = ap_const_logic_0;
    end
end
always @ (ap_start or ap_CS_fsm)
begin
    case (ap_CS_fsm)
        ap_ST_st1_fsm_0 : 
            if (~(ap_start == ap_const_logic_0)) begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end else begin
                ap_NS_fsm = ap_ST_st1_fsm_0;
            end
        ap_ST_st2_fsm_1 : 
            ap_NS_fsm = ap_ST_st3_fsm_2;
        ap_ST_st3_fsm_2 : 
            ap_NS_fsm = ap_ST_st4_fsm_3;
        ap_ST_st4_fsm_3 : 
            ap_NS_fsm = ap_ST_st5_fsm_4;
        ap_ST_st5_fsm_4 : 
            ap_NS_fsm = ap_ST_st6_fsm_5;
        ap_ST_st6_fsm_5 : 
            ap_NS_fsm = ap_ST_st7_fsm_6;
        ap_ST_st7_fsm_6 : 
            ap_NS_fsm = ap_ST_st1_fsm_0;
        default : 
            ap_NS_fsm = 'bx;
    endcase
end
assign ap_return = (tmp_2_cast_fu_47_p1 + z_V);
assign grp_fu_41_ce = ap_const_logic_1;
assign grp_fu_41_p0 = grp_fu_41_p00;
assign grp_fu_41_p00 = $unsigned(tmp_1_cast_fu_37_p0);
assign grp_fu_41_p1 = grp_fu_41_p10;
assign grp_fu_41_p10 = $unsigned(x_V);
assign tmp_1_cast_fu_37_p0 = $signed(y_V);
assign tmp_2_cast_fu_47_p1 = $unsigned(tmp_2_reg_76);


endmodule //mul_add

