-- -------------------------------------------------------------
--
-- Module: firrc
-- Generated by MATLAB(R) 9.0 and the Filter Design HDL Coder 3.0.
-- Generated on: 2016-05-24 15:54:25
-- -------------------------------------------------------------

-- -------------------------------------------------------------
-- HDL Code Generation Options:
--
-- TargetLanguage: VHDL
-- NumMultipliers: 2
-- Name: firrc
-- InputDataType: numerictype(1,16,0)
-- GenerateHDLTestBench: off

-- -------------------------------------------------------------
-- HDL Implementation    : Fully parallel
-- -------------------------------------------------------------
-- Filter Settings:
--
-- Discrete-Time FIR Multirate Filter (real)
-- -----------------------------------------
-- Filter Structure      : Direct-Form FIR Polyphase Sample-Rate Converter
-- Interpolation Factor  : 125
-- Decimation Factor     : 32
-- Polyphase Length      : 2
-- Filter Length         : 141
-- Stable                : Yes
-- Linear Phase          : Yes (Type 1)
--
-- Arithmetic            : fixed
-- Numerator             : s16,17 -> [-2.500000e-01 2.500000e-01)
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.numeric_std.ALL;

ENTITY firrc IS
   PORT( clk                             :   IN    std_logic; 
         clk_enable                      :   IN    std_logic; 
         reset                           :   IN    std_logic; 
         filter_in                       :   IN    std_logic_vector(15 DOWNTO 0); -- sfix16
         filter_out                      :   OUT   std_logic_vector(32 DOWNTO 0); -- sfix33_En17
         ce_in                           :   OUT   std_logic; 
         ce_out                          :   OUT   std_logic  
         );

END firrc;


----------------------------------------------------------------
--Module Architecture: firrc
----------------------------------------------------------------
ARCHITECTURE rtl OF firrc IS
  -- Local Functions
  -- Type Definitions
  TYPE delay_pipeline_type IS ARRAY (NATURAL range <>) OF signed(15 DOWNTO 0); -- sfix16
  -- Constants
  CONSTANT coeffphase1_1                  : signed(15 DOWNTO 0) := to_signed(416, 16); -- sfix16_En17
  CONSTANT coeffphase1_2                  : signed(15 DOWNTO 0) := to_signed(453, 16); -- sfix16_En17
  CONSTANT coeffphase2_1                  : signed(15 DOWNTO 0) := to_signed(-9308, 16); -- sfix16_En17
  CONSTANT coeffphase2_2                  : signed(15 DOWNTO 0) := to_signed(54, 16); -- sfix16_En17
  CONSTANT coeffphase3_1                  : signed(15 DOWNTO 0) := to_signed(-874, 16); -- sfix16_En17
  CONSTANT coeffphase3_2                  : signed(15 DOWNTO 0) := to_signed(-352, 16); -- sfix16_En17
  CONSTANT coeffphase4_1                  : signed(15 DOWNTO 0) := to_signed(-248, 16); -- sfix16_En17
  CONSTANT coeffphase4_2                  : signed(15 DOWNTO 0) := to_signed(-616, 16); -- sfix16_En17
  CONSTANT coeffphase5_1                  : signed(15 DOWNTO 0) := to_signed(116, 16); -- sfix16_En17
  CONSTANT coeffphase5_2                  : signed(15 DOWNTO 0) := to_signed(-647, 16); -- sfix16_En17
  CONSTANT coeffphase6_1                  : signed(15 DOWNTO 0) := to_signed(432, 16); -- sfix16_En17
  CONSTANT coeffphase6_2                  : signed(15 DOWNTO 0) := to_signed(-443, 16); -- sfix16_En17
  CONSTANT coeffphase7_1                  : signed(15 DOWNTO 0) := to_signed(597, 16); -- sfix16_En17
  CONSTANT coeffphase7_2                  : signed(15 DOWNTO 0) := to_signed(-88, 16); -- sfix16_En17
  CONSTANT coeffphase8_1                  : signed(15 DOWNTO 0) := to_signed(545, 16); -- sfix16_En17
  CONSTANT coeffphase8_2                  : signed(15 DOWNTO 0) := to_signed(287, 16); -- sfix16_En17
  CONSTANT coeffphase9_1                  : signed(15 DOWNTO 0) := to_signed(287, 16); -- sfix16_En17
  CONSTANT coeffphase9_2                  : signed(15 DOWNTO 0) := to_signed(545, 16); -- sfix16_En17
  CONSTANT coeffphase10_1                 : signed(15 DOWNTO 0) := to_signed(-88, 16); -- sfix16_En17
  CONSTANT coeffphase10_2                 : signed(15 DOWNTO 0) := to_signed(597, 16); -- sfix16_En17
  CONSTANT coeffphase11_1                 : signed(15 DOWNTO 0) := to_signed(-443, 16); -- sfix16_En17
  CONSTANT coeffphase11_2                 : signed(15 DOWNTO 0) := to_signed(432, 16); -- sfix16_En17
  CONSTANT coeffphase12_1                 : signed(15 DOWNTO 0) := to_signed(-647, 16); -- sfix16_En17
  CONSTANT coeffphase12_2                 : signed(15 DOWNTO 0) := to_signed(116, 16); -- sfix16_En17
  CONSTANT coeffphase13_1                 : signed(15 DOWNTO 0) := to_signed(-616, 16); -- sfix16_En17
  CONSTANT coeffphase13_2                 : signed(15 DOWNTO 0) := to_signed(-248, 16); -- sfix16_En17
  CONSTANT coeffphase14_1                 : signed(15 DOWNTO 0) := to_signed(-352, 16); -- sfix16_En17
  CONSTANT coeffphase14_2                 : signed(15 DOWNTO 0) := to_signed(-874, 16); -- sfix16_En17
  CONSTANT coeffphase15_1                 : signed(15 DOWNTO 0) := to_signed(54, 16); -- sfix16_En17
  CONSTANT coeffphase15_2                 : signed(15 DOWNTO 0) := to_signed(-9308, 16); -- sfix16_En17
  CONSTANT coeffphase16_1                 : signed(15 DOWNTO 0) := to_signed(453, 16); -- sfix16_En17
  CONSTANT coeffphase16_2                 : signed(15 DOWNTO 0) := to_signed(416, 16); -- sfix16_En17
  CONSTANT coeffphase17_1                 : signed(15 DOWNTO 0) := to_signed(701, 16); -- sfix16_En17
  CONSTANT coeffphase17_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase18_1                 : signed(15 DOWNTO 0) := to_signed(699, 16); -- sfix16_En17
  CONSTANT coeffphase18_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase19_1                 : signed(15 DOWNTO 0) := to_signed(429, 16); -- sfix16_En17
  CONSTANT coeffphase19_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase20_1                 : signed(15 DOWNTO 0) := to_signed(-10, 16); -- sfix16_En17
  CONSTANT coeffphase20_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase21_1                 : signed(15 DOWNTO 0) := to_signed(-467, 16); -- sfix16_En17
  CONSTANT coeffphase21_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase22_1                 : signed(15 DOWNTO 0) := to_signed(-768, 16); -- sfix16_En17
  CONSTANT coeffphase22_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase23_1                 : signed(15 DOWNTO 0) := to_signed(-795, 16); -- sfix16_En17
  CONSTANT coeffphase23_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase24_1                 : signed(15 DOWNTO 0) := to_signed(-523, 16); -- sfix16_En17
  CONSTANT coeffphase24_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase25_1                 : signed(15 DOWNTO 0) := to_signed(-43, 16); -- sfix16_En17
  CONSTANT coeffphase25_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase26_1                 : signed(15 DOWNTO 0) := to_signed(476, 16); -- sfix16_En17
  CONSTANT coeffphase26_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase27_1                 : signed(15 DOWNTO 0) := to_signed(841, 16); -- sfix16_En17
  CONSTANT coeffphase27_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase28_1                 : signed(15 DOWNTO 0) := to_signed(909, 16); -- sfix16_En17
  CONSTANT coeffphase28_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase29_1                 : signed(15 DOWNTO 0) := to_signed(637, 16); -- sfix16_En17
  CONSTANT coeffphase29_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase30_1                 : signed(15 DOWNTO 0) := to_signed(111, 16); -- sfix16_En17
  CONSTANT coeffphase30_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase31_1                 : signed(15 DOWNTO 0) := to_signed(-486, 16); -- sfix16_En17
  CONSTANT coeffphase31_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase32_1                 : signed(15 DOWNTO 0) := to_signed(-930, 16); -- sfix16_En17
  CONSTANT coeffphase32_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase33_1                 : signed(15 DOWNTO 0) := to_signed(-1050, 16); -- sfix16_En17
  CONSTANT coeffphase33_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase34_1                 : signed(15 DOWNTO 0) := to_signed(-779, 16); -- sfix16_En17
  CONSTANT coeffphase34_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase35_1                 : signed(15 DOWNTO 0) := to_signed(-197, 16); -- sfix16_En17
  CONSTANT coeffphase35_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase36_1                 : signed(15 DOWNTO 0) := to_signed(494, 16); -- sfix16_En17
  CONSTANT coeffphase36_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase37_1                 : signed(15 DOWNTO 0) := to_signed(1041, 16); -- sfix16_En17
  CONSTANT coeffphase37_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase38_1                 : signed(15 DOWNTO 0) := to_signed(1228, 16); -- sfix16_En17
  CONSTANT coeffphase38_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase39_1                 : signed(15 DOWNTO 0) := to_signed(961, 16); -- sfix16_En17
  CONSTANT coeffphase39_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase40_1                 : signed(15 DOWNTO 0) := to_signed(311, 16); -- sfix16_En17
  CONSTANT coeffphase40_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase41_1                 : signed(15 DOWNTO 0) := to_signed(-502, 16); -- sfix16_En17
  CONSTANT coeffphase41_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase42_1                 : signed(15 DOWNTO 0) := to_signed(-1182, 16); -- sfix16_En17
  CONSTANT coeffphase42_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase43_1                 : signed(15 DOWNTO 0) := to_signed(-1462, 16); -- sfix16_En17
  CONSTANT coeffphase43_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase44_1                 : signed(15 DOWNTO 0) := to_signed(-1205, 16); -- sfix16_En17
  CONSTANT coeffphase44_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase45_1                 : signed(15 DOWNTO 0) := to_signed(-468, 16); -- sfix16_En17
  CONSTANT coeffphase45_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase46_1                 : signed(15 DOWNTO 0) := to_signed(508, 16); -- sfix16_En17
  CONSTANT coeffphase46_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase47_1                 : signed(15 DOWNTO 0) := to_signed(1375, 16); -- sfix16_En17
  CONSTANT coeffphase47_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase48_1                 : signed(15 DOWNTO 0) := to_signed(1789, 16); -- sfix16_En17
  CONSTANT coeffphase48_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase49_1                 : signed(15 DOWNTO 0) := to_signed(1557, 16); -- sfix16_En17
  CONSTANT coeffphase49_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase50_1                 : signed(15 DOWNTO 0) := to_signed(701, 16); -- sfix16_En17
  CONSTANT coeffphase50_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase51_1                 : signed(15 DOWNTO 0) := to_signed(-514, 16); -- sfix16_En17
  CONSTANT coeffphase51_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase52_1                 : signed(15 DOWNTO 0) := to_signed(-1660, 16); -- sfix16_En17
  CONSTANT coeffphase52_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase53_1                 : signed(15 DOWNTO 0) := to_signed(-2291, 16); -- sfix16_En17
  CONSTANT coeffphase53_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase54_1                 : signed(15 DOWNTO 0) := to_signed(-2107, 16); -- sfix16_En17
  CONSTANT coeffphase54_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase55_1                 : signed(15 DOWNTO 0) := to_signed(-1075, 16); -- sfix16_En17
  CONSTANT coeffphase55_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase56_1                 : signed(15 DOWNTO 0) := to_signed(517, 16); -- sfix16_En17
  CONSTANT coeffphase56_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase57_1                 : signed(15 DOWNTO 0) := to_signed(2138, 16); -- sfix16_En17
  CONSTANT coeffphase57_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase58_1                 : signed(15 DOWNTO 0) := to_signed(3163, 16); -- sfix16_En17
  CONSTANT coeffphase58_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase59_1                 : signed(15 DOWNTO 0) := to_signed(3102, 16); -- sfix16_En17
  CONSTANT coeffphase59_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase60_1                 : signed(15 DOWNTO 0) := to_signed(1781, 16); -- sfix16_En17
  CONSTANT coeffphase60_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase61_1                 : signed(15 DOWNTO 0) := to_signed(-519, 16); -- sfix16_En17
  CONSTANT coeffphase61_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase62_1                 : signed(15 DOWNTO 0) := to_signed(-3128, 16); -- sfix16_En17
  CONSTANT coeffphase62_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase63_1                 : signed(15 DOWNTO 0) := to_signed(-5089, 16); -- sfix16_En17
  CONSTANT coeffphase63_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase64_1                 : signed(15 DOWNTO 0) := to_signed(-5466, 16); -- sfix16_En17
  CONSTANT coeffphase64_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase65_1                 : signed(15 DOWNTO 0) := to_signed(-3653, 16); -- sfix16_En17
  CONSTANT coeffphase65_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase66_1                 : signed(15 DOWNTO 0) := to_signed(524, 16); -- sfix16_En17
  CONSTANT coeffphase66_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase67_1                 : signed(15 DOWNTO 0) := to_signed(6544, 16); -- sfix16_En17
  CONSTANT coeffphase67_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase68_1                 : signed(15 DOWNTO 0) := to_signed(13379, 16); -- sfix16_En17
  CONSTANT coeffphase68_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase69_1                 : signed(15 DOWNTO 0) := to_signed(19669, 16); -- sfix16_En17
  CONSTANT coeffphase69_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase70_1                 : signed(15 DOWNTO 0) := to_signed(24099, 16); -- sfix16_En17
  CONSTANT coeffphase70_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase71_1                 : signed(15 DOWNTO 0) := to_signed(25690, 16); -- sfix16_En17
  CONSTANT coeffphase71_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase72_1                 : signed(15 DOWNTO 0) := to_signed(24099, 16); -- sfix16_En17
  CONSTANT coeffphase72_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase73_1                 : signed(15 DOWNTO 0) := to_signed(19669, 16); -- sfix16_En17
  CONSTANT coeffphase73_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase74_1                 : signed(15 DOWNTO 0) := to_signed(13379, 16); -- sfix16_En17
  CONSTANT coeffphase74_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase75_1                 : signed(15 DOWNTO 0) := to_signed(6544, 16); -- sfix16_En17
  CONSTANT coeffphase75_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase76_1                 : signed(15 DOWNTO 0) := to_signed(524, 16); -- sfix16_En17
  CONSTANT coeffphase76_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase77_1                 : signed(15 DOWNTO 0) := to_signed(-3653, 16); -- sfix16_En17
  CONSTANT coeffphase77_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase78_1                 : signed(15 DOWNTO 0) := to_signed(-5466, 16); -- sfix16_En17
  CONSTANT coeffphase78_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase79_1                 : signed(15 DOWNTO 0) := to_signed(-5089, 16); -- sfix16_En17
  CONSTANT coeffphase79_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase80_1                 : signed(15 DOWNTO 0) := to_signed(-3128, 16); -- sfix16_En17
  CONSTANT coeffphase80_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase81_1                 : signed(15 DOWNTO 0) := to_signed(-519, 16); -- sfix16_En17
  CONSTANT coeffphase81_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase82_1                 : signed(15 DOWNTO 0) := to_signed(1781, 16); -- sfix16_En17
  CONSTANT coeffphase82_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase83_1                 : signed(15 DOWNTO 0) := to_signed(3102, 16); -- sfix16_En17
  CONSTANT coeffphase83_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase84_1                 : signed(15 DOWNTO 0) := to_signed(3163, 16); -- sfix16_En17
  CONSTANT coeffphase84_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase85_1                 : signed(15 DOWNTO 0) := to_signed(2138, 16); -- sfix16_En17
  CONSTANT coeffphase85_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase86_1                 : signed(15 DOWNTO 0) := to_signed(517, 16); -- sfix16_En17
  CONSTANT coeffphase86_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase87_1                 : signed(15 DOWNTO 0) := to_signed(-1075, 16); -- sfix16_En17
  CONSTANT coeffphase87_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase88_1                 : signed(15 DOWNTO 0) := to_signed(-2107, 16); -- sfix16_En17
  CONSTANT coeffphase88_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase89_1                 : signed(15 DOWNTO 0) := to_signed(-2291, 16); -- sfix16_En17
  CONSTANT coeffphase89_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase90_1                 : signed(15 DOWNTO 0) := to_signed(-1660, 16); -- sfix16_En17
  CONSTANT coeffphase90_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase91_1                 : signed(15 DOWNTO 0) := to_signed(-514, 16); -- sfix16_En17
  CONSTANT coeffphase91_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase92_1                 : signed(15 DOWNTO 0) := to_signed(701, 16); -- sfix16_En17
  CONSTANT coeffphase92_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase93_1                 : signed(15 DOWNTO 0) := to_signed(1557, 16); -- sfix16_En17
  CONSTANT coeffphase93_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase94_1                 : signed(15 DOWNTO 0) := to_signed(1789, 16); -- sfix16_En17
  CONSTANT coeffphase94_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase95_1                 : signed(15 DOWNTO 0) := to_signed(1375, 16); -- sfix16_En17
  CONSTANT coeffphase95_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase96_1                 : signed(15 DOWNTO 0) := to_signed(508, 16); -- sfix16_En17
  CONSTANT coeffphase96_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase97_1                 : signed(15 DOWNTO 0) := to_signed(-468, 16); -- sfix16_En17
  CONSTANT coeffphase97_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase98_1                 : signed(15 DOWNTO 0) := to_signed(-1205, 16); -- sfix16_En17
  CONSTANT coeffphase98_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase99_1                 : signed(15 DOWNTO 0) := to_signed(-1462, 16); -- sfix16_En17
  CONSTANT coeffphase99_2                 : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase100_1                : signed(15 DOWNTO 0) := to_signed(-1182, 16); -- sfix16_En17
  CONSTANT coeffphase100_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase101_1                : signed(15 DOWNTO 0) := to_signed(-502, 16); -- sfix16_En17
  CONSTANT coeffphase101_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase102_1                : signed(15 DOWNTO 0) := to_signed(311, 16); -- sfix16_En17
  CONSTANT coeffphase102_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase103_1                : signed(15 DOWNTO 0) := to_signed(961, 16); -- sfix16_En17
  CONSTANT coeffphase103_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase104_1                : signed(15 DOWNTO 0) := to_signed(1228, 16); -- sfix16_En17
  CONSTANT coeffphase104_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase105_1                : signed(15 DOWNTO 0) := to_signed(1041, 16); -- sfix16_En17
  CONSTANT coeffphase105_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase106_1                : signed(15 DOWNTO 0) := to_signed(494, 16); -- sfix16_En17
  CONSTANT coeffphase106_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase107_1                : signed(15 DOWNTO 0) := to_signed(-197, 16); -- sfix16_En17
  CONSTANT coeffphase107_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase108_1                : signed(15 DOWNTO 0) := to_signed(-779, 16); -- sfix16_En17
  CONSTANT coeffphase108_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase109_1                : signed(15 DOWNTO 0) := to_signed(-1050, 16); -- sfix16_En17
  CONSTANT coeffphase109_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase110_1                : signed(15 DOWNTO 0) := to_signed(-930, 16); -- sfix16_En17
  CONSTANT coeffphase110_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase111_1                : signed(15 DOWNTO 0) := to_signed(-486, 16); -- sfix16_En17
  CONSTANT coeffphase111_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase112_1                : signed(15 DOWNTO 0) := to_signed(111, 16); -- sfix16_En17
  CONSTANT coeffphase112_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase113_1                : signed(15 DOWNTO 0) := to_signed(637, 16); -- sfix16_En17
  CONSTANT coeffphase113_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase114_1                : signed(15 DOWNTO 0) := to_signed(909, 16); -- sfix16_En17
  CONSTANT coeffphase114_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase115_1                : signed(15 DOWNTO 0) := to_signed(841, 16); -- sfix16_En17
  CONSTANT coeffphase115_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase116_1                : signed(15 DOWNTO 0) := to_signed(476, 16); -- sfix16_En17
  CONSTANT coeffphase116_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase117_1                : signed(15 DOWNTO 0) := to_signed(-43, 16); -- sfix16_En17
  CONSTANT coeffphase117_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase118_1                : signed(15 DOWNTO 0) := to_signed(-523, 16); -- sfix16_En17
  CONSTANT coeffphase118_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase119_1                : signed(15 DOWNTO 0) := to_signed(-795, 16); -- sfix16_En17
  CONSTANT coeffphase119_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase120_1                : signed(15 DOWNTO 0) := to_signed(-768, 16); -- sfix16_En17
  CONSTANT coeffphase120_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase121_1                : signed(15 DOWNTO 0) := to_signed(-467, 16); -- sfix16_En17
  CONSTANT coeffphase121_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase122_1                : signed(15 DOWNTO 0) := to_signed(-10, 16); -- sfix16_En17
  CONSTANT coeffphase122_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase123_1                : signed(15 DOWNTO 0) := to_signed(429, 16); -- sfix16_En17
  CONSTANT coeffphase123_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase124_1                : signed(15 DOWNTO 0) := to_signed(699, 16); -- sfix16_En17
  CONSTANT coeffphase124_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17
  CONSTANT coeffphase125_1                : signed(15 DOWNTO 0) := to_signed(701, 16); -- sfix16_En17
  CONSTANT coeffphase125_2                : signed(15 DOWNTO 0) := to_signed(0, 16); -- sfix16_En17

  -- Signals
  SIGNAL cur_count                        : unsigned(6 DOWNTO 0); -- ufix7
  SIGNAL phase_4                          : std_logic; -- boolean
  SIGNAL phase_1                          : std_logic; -- boolean
  SIGNAL ce_out_reg                       : std_logic; -- boolean
  SIGNAL ce_in_reg                        : std_logic; -- boolean
  SIGNAL ce_out_phase                     : std_logic; -- boolean
  SIGNAL delay_pipeline                   : delay_pipeline_type(0 TO 1); -- sfix16
  SIGNAL product                          : signed(31 DOWNTO 0); -- sfix32_En17
  SIGNAL product_mux                      : signed(15 DOWNTO 0); -- sfix16_En17
  SIGNAL product_1                        : signed(31 DOWNTO 0); -- sfix32_En17
  SIGNAL product_mux_1                    : signed(15 DOWNTO 0); -- sfix16_En17
  SIGNAL product_1_cast                   : signed(32 DOWNTO 0); -- sfix33_En17
  SIGNAL fir_sum                          : signed(32 DOWNTO 0); -- sfix33_En17
  SIGNAL add_temp                         : signed(33 DOWNTO 0); -- sfix34_En17
  SIGNAL output_typeconvert               : signed(32 DOWNTO 0); -- sfix33_En17
  SIGNAL output_register                  : signed(32 DOWNTO 0); -- sfix33_En17


BEGIN

  -- Block Statements
  --   ------------------ CE Output Generation ------------------

  ce_output : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      cur_count <= to_unsigned(0, 7);
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        IF cur_count = to_unsigned(127, 7) THEN
          cur_count <= to_unsigned(0, 7);
        ELSE
          cur_count <= cur_count + 1;
        END IF;
      END IF;
    END IF; 
  END PROCESS ce_output;

  phase_4 <= '1' WHEN  (((cur_count = to_unsigned(0, 7))  OR
                         (cur_count = to_unsigned(4, 7))  OR
                         (cur_count = to_unsigned(8, 7))  OR
                         (cur_count = to_unsigned(12, 7))  OR
                         (cur_count = to_unsigned(16, 7))  OR
                         (cur_count = to_unsigned(20, 7))  OR
                         (cur_count = to_unsigned(24, 7))  OR
                         (cur_count = to_unsigned(28, 7))  OR
                         (cur_count = to_unsigned(32, 7))  OR
                         (cur_count = to_unsigned(36, 7))  OR
                         (cur_count = to_unsigned(40, 7))  OR
                         (cur_count = to_unsigned(44, 7))  OR
                         (cur_count = to_unsigned(48, 7))  OR
                         (cur_count = to_unsigned(52, 7))  OR
                         (cur_count = to_unsigned(56, 7))  OR
                         (cur_count = to_unsigned(60, 7))  OR
                         (cur_count = to_unsigned(64, 7))  OR
                         (cur_count = to_unsigned(68, 7))  OR
                         (cur_count = to_unsigned(72, 7))  OR
                         (cur_count = to_unsigned(76, 7))  OR
                         (cur_count = to_unsigned(80, 7))  OR
                         (cur_count = to_unsigned(84, 7))  OR
                         (cur_count = to_unsigned(88, 7))  OR
                         (cur_count = to_unsigned(92, 7))  OR
                         (cur_count = to_unsigned(96, 7))  OR
                         (cur_count = to_unsigned(100, 7))  OR
                         (cur_count = to_unsigned(104, 7))  OR
                         (cur_count = to_unsigned(108, 7))  OR
                         (cur_count = to_unsigned(112, 7))  OR
                         (cur_count = to_unsigned(116, 7))  OR
                         (cur_count = to_unsigned(120, 7))  OR
                         (cur_count = to_unsigned(124, 7)))  AND clk_enable = '1') ELSE '0';

  phase_1 <= '1' WHEN  (((cur_count = to_unsigned(1, 7))  OR
                         (cur_count = to_unsigned(2, 7))  OR
                         (cur_count = to_unsigned(3, 7))  OR
                         (cur_count = to_unsigned(4, 7))  OR
                         (cur_count = to_unsigned(5, 7))  OR
                         (cur_count = to_unsigned(6, 7))  OR
                         (cur_count = to_unsigned(7, 7))  OR
                         (cur_count = to_unsigned(8, 7))  OR
                         (cur_count = to_unsigned(9, 7))  OR
                         (cur_count = to_unsigned(10, 7))  OR
                         (cur_count = to_unsigned(11, 7))  OR
                         (cur_count = to_unsigned(12, 7))  OR
                         (cur_count = to_unsigned(13, 7))  OR
                         (cur_count = to_unsigned(14, 7))  OR
                         (cur_count = to_unsigned(15, 7))  OR
                         (cur_count = to_unsigned(16, 7))  OR
                         (cur_count = to_unsigned(17, 7))  OR
                         (cur_count = to_unsigned(18, 7))  OR
                         (cur_count = to_unsigned(19, 7))  OR
                         (cur_count = to_unsigned(20, 7))  OR
                         (cur_count = to_unsigned(21, 7))  OR
                         (cur_count = to_unsigned(22, 7))  OR
                         (cur_count = to_unsigned(23, 7))  OR
                         (cur_count = to_unsigned(24, 7))  OR
                         (cur_count = to_unsigned(25, 7))  OR
                         (cur_count = to_unsigned(26, 7))  OR
                         (cur_count = to_unsigned(27, 7))  OR
                         (cur_count = to_unsigned(28, 7))  OR
                         (cur_count = to_unsigned(29, 7))  OR
                         (cur_count = to_unsigned(30, 7))  OR
                         (cur_count = to_unsigned(31, 7))  OR
                         (cur_count = to_unsigned(32, 7))  OR
                         (cur_count = to_unsigned(33, 7))  OR
                         (cur_count = to_unsigned(34, 7))  OR
                         (cur_count = to_unsigned(35, 7))  OR
                         (cur_count = to_unsigned(36, 7))  OR
                         (cur_count = to_unsigned(37, 7))  OR
                         (cur_count = to_unsigned(38, 7))  OR
                         (cur_count = to_unsigned(39, 7))  OR
                         (cur_count = to_unsigned(40, 7))  OR
                         (cur_count = to_unsigned(41, 7))  OR
                         (cur_count = to_unsigned(42, 7))  OR
                         (cur_count = to_unsigned(43, 7))  OR
                         (cur_count = to_unsigned(45, 7))  OR
                         (cur_count = to_unsigned(46, 7))  OR
                         (cur_count = to_unsigned(47, 7))  OR
                         (cur_count = to_unsigned(48, 7))  OR
                         (cur_count = to_unsigned(49, 7))  OR
                         (cur_count = to_unsigned(50, 7))  OR
                         (cur_count = to_unsigned(51, 7))  OR
                         (cur_count = to_unsigned(52, 7))  OR
                         (cur_count = to_unsigned(53, 7))  OR
                         (cur_count = to_unsigned(54, 7))  OR
                         (cur_count = to_unsigned(55, 7))  OR
                         (cur_count = to_unsigned(56, 7))  OR
                         (cur_count = to_unsigned(57, 7))  OR
                         (cur_count = to_unsigned(58, 7))  OR
                         (cur_count = to_unsigned(59, 7))  OR
                         (cur_count = to_unsigned(60, 7))  OR
                         (cur_count = to_unsigned(61, 7))  OR
                         (cur_count = to_unsigned(62, 7))  OR
                         (cur_count = to_unsigned(63, 7))  OR
                         (cur_count = to_unsigned(64, 7))  OR
                         (cur_count = to_unsigned(65, 7))  OR
                         (cur_count = to_unsigned(66, 7))  OR
                         (cur_count = to_unsigned(67, 7))  OR
                         (cur_count = to_unsigned(68, 7))  OR
                         (cur_count = to_unsigned(69, 7))  OR
                         (cur_count = to_unsigned(70, 7))  OR
                         (cur_count = to_unsigned(71, 7))  OR
                         (cur_count = to_unsigned(72, 7))  OR
                         (cur_count = to_unsigned(73, 7))  OR
                         (cur_count = to_unsigned(74, 7))  OR
                         (cur_count = to_unsigned(75, 7))  OR
                         (cur_count = to_unsigned(76, 7))  OR
                         (cur_count = to_unsigned(77, 7))  OR
                         (cur_count = to_unsigned(78, 7))  OR
                         (cur_count = to_unsigned(79, 7))  OR
                         (cur_count = to_unsigned(80, 7))  OR
                         (cur_count = to_unsigned(81, 7))  OR
                         (cur_count = to_unsigned(82, 7))  OR
                         (cur_count = to_unsigned(83, 7))  OR
                         (cur_count = to_unsigned(84, 7))  OR
                         (cur_count = to_unsigned(85, 7))  OR
                         (cur_count = to_unsigned(86, 7))  OR
                         (cur_count = to_unsigned(87, 7))  OR
                         (cur_count = to_unsigned(89, 7))  OR
                         (cur_count = to_unsigned(90, 7))  OR
                         (cur_count = to_unsigned(91, 7))  OR
                         (cur_count = to_unsigned(92, 7))  OR
                         (cur_count = to_unsigned(93, 7))  OR
                         (cur_count = to_unsigned(94, 7))  OR
                         (cur_count = to_unsigned(95, 7))  OR
                         (cur_count = to_unsigned(96, 7))  OR
                         (cur_count = to_unsigned(97, 7))  OR
                         (cur_count = to_unsigned(98, 7))  OR
                         (cur_count = to_unsigned(99, 7))  OR
                         (cur_count = to_unsigned(100, 7))  OR
                         (cur_count = to_unsigned(101, 7))  OR
                         (cur_count = to_unsigned(102, 7))  OR
                         (cur_count = to_unsigned(103, 7))  OR
                         (cur_count = to_unsigned(104, 7))  OR
                         (cur_count = to_unsigned(105, 7))  OR
                         (cur_count = to_unsigned(106, 7))  OR
                         (cur_count = to_unsigned(107, 7))  OR
                         (cur_count = to_unsigned(108, 7))  OR
                         (cur_count = to_unsigned(109, 7))  OR
                         (cur_count = to_unsigned(110, 7))  OR
                         (cur_count = to_unsigned(111, 7))  OR
                         (cur_count = to_unsigned(112, 7))  OR
                         (cur_count = to_unsigned(113, 7))  OR
                         (cur_count = to_unsigned(114, 7))  OR
                         (cur_count = to_unsigned(115, 7))  OR
                         (cur_count = to_unsigned(116, 7))  OR
                         (cur_count = to_unsigned(117, 7))  OR
                         (cur_count = to_unsigned(118, 7))  OR
                         (cur_count = to_unsigned(119, 7))  OR
                         (cur_count = to_unsigned(120, 7))  OR
                         (cur_count = to_unsigned(121, 7))  OR
                         (cur_count = to_unsigned(122, 7))  OR
                         (cur_count = to_unsigned(123, 7))  OR
                         (cur_count = to_unsigned(124, 7))  OR
                         (cur_count = to_unsigned(125, 7))  OR
                         (cur_count = to_unsigned(126, 7))  OR
                         (cur_count = to_unsigned(127, 7)))  AND clk_enable = '1') ELSE '0';

  --   ------------------ CE Output Register ------------------

  ce_out_delay_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      ce_out_reg <= '0';
    ELSIF clk'event AND clk = '1' THEN
      ce_out_reg <= phase_1;
      
    END IF; 
  END PROCESS ce_out_delay_process;

  --   ------------------ CE Input Register ------------------

  ce_input_register : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      ce_in_reg <= '0';
    ELSIF clk'event AND clk = '1' THEN
      ce_in_reg <= phase_4;
      
    END IF; 
  END PROCESS ce_input_register;

  ce_out_phase <=  ce_out_reg AND clk_enable;

  --   ---------------- Delay Registers ----------------

  Delay_Pipeline_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      delay_pipeline(0 TO 1) <= (OTHERS => (OTHERS => '0'));
    ELSIF clk'event AND clk = '1' THEN
      IF phase_4 = '1' THEN
        delay_pipeline(0) <= signed(filter_in);
        delay_pipeline(1) <= delay_pipeline(0);
      END IF;
    END IF; 
  END PROCESS Delay_Pipeline_process;

  product_mux <= coeffphase1_2 WHEN ( cur_count = to_unsigned(1, 7) ) ELSE
                      coeffphase33_2 WHEN ( cur_count = to_unsigned(2, 7) ) ELSE
                      coeffphase65_2 WHEN ( cur_count = to_unsigned(3, 7) ) ELSE
                      coeffphase97_2 WHEN ( cur_count = to_unsigned(4, 7) ) ELSE
                      coeffphase4_2 WHEN ( cur_count = to_unsigned(5, 7) ) ELSE
                      coeffphase36_2 WHEN ( cur_count = to_unsigned(6, 7) ) ELSE
                      coeffphase68_2 WHEN ( cur_count = to_unsigned(7, 7) ) ELSE
                      coeffphase100_2 WHEN ( cur_count = to_unsigned(8, 7) ) ELSE
                      coeffphase7_2 WHEN ( cur_count = to_unsigned(9, 7) ) ELSE
                      coeffphase39_2 WHEN ( cur_count = to_unsigned(10, 7) ) ELSE
                      coeffphase71_2 WHEN ( cur_count = to_unsigned(11, 7) ) ELSE
                      coeffphase103_2 WHEN ( cur_count = to_unsigned(12, 7) ) ELSE
                      coeffphase10_2 WHEN ( cur_count = to_unsigned(13, 7) ) ELSE
                      coeffphase42_2 WHEN ( cur_count = to_unsigned(14, 7) ) ELSE
                      coeffphase74_2 WHEN ( cur_count = to_unsigned(15, 7) ) ELSE
                      coeffphase106_2 WHEN ( cur_count = to_unsigned(16, 7) ) ELSE
                      coeffphase13_2 WHEN ( cur_count = to_unsigned(17, 7) ) ELSE
                      coeffphase45_2 WHEN ( cur_count = to_unsigned(18, 7) ) ELSE
                      coeffphase77_2 WHEN ( cur_count = to_unsigned(19, 7) ) ELSE
                      coeffphase109_2 WHEN ( cur_count = to_unsigned(20, 7) ) ELSE
                      coeffphase16_2 WHEN ( cur_count = to_unsigned(21, 7) ) ELSE
                      coeffphase48_2 WHEN ( cur_count = to_unsigned(22, 7) ) ELSE
                      coeffphase80_2 WHEN ( cur_count = to_unsigned(23, 7) ) ELSE
                      coeffphase112_2 WHEN ( cur_count = to_unsigned(24, 7) ) ELSE
                      coeffphase19_2 WHEN ( cur_count = to_unsigned(25, 7) ) ELSE
                      coeffphase51_2 WHEN ( cur_count = to_unsigned(26, 7) ) ELSE
                      coeffphase83_2 WHEN ( cur_count = to_unsigned(27, 7) ) ELSE
                      coeffphase115_2 WHEN ( cur_count = to_unsigned(28, 7) ) ELSE
                      coeffphase22_2 WHEN ( cur_count = to_unsigned(29, 7) ) ELSE
                      coeffphase54_2 WHEN ( cur_count = to_unsigned(30, 7) ) ELSE
                      coeffphase86_2 WHEN ( cur_count = to_unsigned(31, 7) ) ELSE
                      coeffphase118_2 WHEN ( cur_count = to_unsigned(32, 7) ) ELSE
                      coeffphase25_2 WHEN ( cur_count = to_unsigned(33, 7) ) ELSE
                      coeffphase57_2 WHEN ( cur_count = to_unsigned(34, 7) ) ELSE
                      coeffphase89_2 WHEN ( cur_count = to_unsigned(35, 7) ) ELSE
                      coeffphase121_2 WHEN ( cur_count = to_unsigned(36, 7) ) ELSE
                      coeffphase28_2 WHEN ( cur_count = to_unsigned(37, 7) ) ELSE
                      coeffphase60_2 WHEN ( cur_count = to_unsigned(38, 7) ) ELSE
                      coeffphase92_2 WHEN ( cur_count = to_unsigned(39, 7) ) ELSE
                      coeffphase124_2 WHEN ( cur_count = to_unsigned(40, 7) ) ELSE
                      coeffphase31_2 WHEN ( cur_count = to_unsigned(41, 7) ) ELSE
                      coeffphase63_2 WHEN ( cur_count = to_unsigned(42, 7) ) ELSE
                      coeffphase95_2 WHEN ( cur_count = to_unsigned(43, 7) ) ELSE
                      coeffphase2_2 WHEN ( cur_count = to_unsigned(45, 7) ) ELSE
                      coeffphase34_2 WHEN ( cur_count = to_unsigned(46, 7) ) ELSE
                      coeffphase66_2 WHEN ( cur_count = to_unsigned(47, 7) ) ELSE
                      coeffphase98_2 WHEN ( cur_count = to_unsigned(48, 7) ) ELSE
                      coeffphase5_2 WHEN ( cur_count = to_unsigned(49, 7) ) ELSE
                      coeffphase37_2 WHEN ( cur_count = to_unsigned(50, 7) ) ELSE
                      coeffphase69_2 WHEN ( cur_count = to_unsigned(51, 7) ) ELSE
                      coeffphase101_2 WHEN ( cur_count = to_unsigned(52, 7) ) ELSE
                      coeffphase8_2 WHEN ( cur_count = to_unsigned(53, 7) ) ELSE
                      coeffphase40_2 WHEN ( cur_count = to_unsigned(54, 7) ) ELSE
                      coeffphase72_2 WHEN ( cur_count = to_unsigned(55, 7) ) ELSE
                      coeffphase104_2 WHEN ( cur_count = to_unsigned(56, 7) ) ELSE
                      coeffphase11_2 WHEN ( cur_count = to_unsigned(57, 7) ) ELSE
                      coeffphase43_2 WHEN ( cur_count = to_unsigned(58, 7) ) ELSE
                      coeffphase75_2 WHEN ( cur_count = to_unsigned(59, 7) ) ELSE
                      coeffphase107_2 WHEN ( cur_count = to_unsigned(60, 7) ) ELSE
                      coeffphase14_2 WHEN ( cur_count = to_unsigned(61, 7) ) ELSE
                      coeffphase46_2 WHEN ( cur_count = to_unsigned(62, 7) ) ELSE
                      coeffphase78_2 WHEN ( cur_count = to_unsigned(63, 7) ) ELSE
                      coeffphase110_2 WHEN ( cur_count = to_unsigned(64, 7) ) ELSE
                      coeffphase17_2 WHEN ( cur_count = to_unsigned(65, 7) ) ELSE
                      coeffphase49_2 WHEN ( cur_count = to_unsigned(66, 7) ) ELSE
                      coeffphase81_2 WHEN ( cur_count = to_unsigned(67, 7) ) ELSE
                      coeffphase113_2 WHEN ( cur_count = to_unsigned(68, 7) ) ELSE
                      coeffphase20_2 WHEN ( cur_count = to_unsigned(69, 7) ) ELSE
                      coeffphase52_2 WHEN ( cur_count = to_unsigned(70, 7) ) ELSE
                      coeffphase84_2 WHEN ( cur_count = to_unsigned(71, 7) ) ELSE
                      coeffphase116_2 WHEN ( cur_count = to_unsigned(72, 7) ) ELSE
                      coeffphase23_2 WHEN ( cur_count = to_unsigned(73, 7) ) ELSE
                      coeffphase55_2 WHEN ( cur_count = to_unsigned(74, 7) ) ELSE
                      coeffphase87_2 WHEN ( cur_count = to_unsigned(75, 7) ) ELSE
                      coeffphase119_2 WHEN ( cur_count = to_unsigned(76, 7) ) ELSE
                      coeffphase26_2 WHEN ( cur_count = to_unsigned(77, 7) ) ELSE
                      coeffphase58_2 WHEN ( cur_count = to_unsigned(78, 7) ) ELSE
                      coeffphase90_2 WHEN ( cur_count = to_unsigned(79, 7) ) ELSE
                      coeffphase122_2 WHEN ( cur_count = to_unsigned(80, 7) ) ELSE
                      coeffphase29_2 WHEN ( cur_count = to_unsigned(81, 7) ) ELSE
                      coeffphase61_2 WHEN ( cur_count = to_unsigned(82, 7) ) ELSE
                      coeffphase93_2 WHEN ( cur_count = to_unsigned(83, 7) ) ELSE
                      coeffphase125_2 WHEN ( cur_count = to_unsigned(84, 7) ) ELSE
                      coeffphase32_2 WHEN ( cur_count = to_unsigned(85, 7) ) ELSE
                      coeffphase64_2 WHEN ( cur_count = to_unsigned(86, 7) ) ELSE
                      coeffphase96_2 WHEN ( cur_count = to_unsigned(87, 7) ) ELSE
                      coeffphase3_2 WHEN ( cur_count = to_unsigned(89, 7) ) ELSE
                      coeffphase35_2 WHEN ( cur_count = to_unsigned(90, 7) ) ELSE
                      coeffphase67_2 WHEN ( cur_count = to_unsigned(91, 7) ) ELSE
                      coeffphase99_2 WHEN ( cur_count = to_unsigned(92, 7) ) ELSE
                      coeffphase6_2 WHEN ( cur_count = to_unsigned(93, 7) ) ELSE
                      coeffphase38_2 WHEN ( cur_count = to_unsigned(94, 7) ) ELSE
                      coeffphase70_2 WHEN ( cur_count = to_unsigned(95, 7) ) ELSE
                      coeffphase102_2 WHEN ( cur_count = to_unsigned(96, 7) ) ELSE
                      coeffphase9_2 WHEN ( cur_count = to_unsigned(97, 7) ) ELSE
                      coeffphase41_2 WHEN ( cur_count = to_unsigned(98, 7) ) ELSE
                      coeffphase73_2 WHEN ( cur_count = to_unsigned(99, 7) ) ELSE
                      coeffphase105_2 WHEN ( cur_count = to_unsigned(100, 7) ) ELSE
                      coeffphase12_2 WHEN ( cur_count = to_unsigned(101, 7) ) ELSE
                      coeffphase44_2 WHEN ( cur_count = to_unsigned(102, 7) ) ELSE
                      coeffphase76_2 WHEN ( cur_count = to_unsigned(103, 7) ) ELSE
                      coeffphase108_2 WHEN ( cur_count = to_unsigned(104, 7) ) ELSE
                      coeffphase15_2 WHEN ( cur_count = to_unsigned(105, 7) ) ELSE
                      coeffphase47_2 WHEN ( cur_count = to_unsigned(106, 7) ) ELSE
                      coeffphase79_2 WHEN ( cur_count = to_unsigned(107, 7) ) ELSE
                      coeffphase111_2 WHEN ( cur_count = to_unsigned(108, 7) ) ELSE
                      coeffphase18_2 WHEN ( cur_count = to_unsigned(109, 7) ) ELSE
                      coeffphase50_2 WHEN ( cur_count = to_unsigned(110, 7) ) ELSE
                      coeffphase82_2 WHEN ( cur_count = to_unsigned(111, 7) ) ELSE
                      coeffphase114_2 WHEN ( cur_count = to_unsigned(112, 7) ) ELSE
                      coeffphase21_2 WHEN ( cur_count = to_unsigned(113, 7) ) ELSE
                      coeffphase53_2 WHEN ( cur_count = to_unsigned(114, 7) ) ELSE
                      coeffphase85_2 WHEN ( cur_count = to_unsigned(115, 7) ) ELSE
                      coeffphase117_2 WHEN ( cur_count = to_unsigned(116, 7) ) ELSE
                      coeffphase24_2 WHEN ( cur_count = to_unsigned(117, 7) ) ELSE
                      coeffphase56_2 WHEN ( cur_count = to_unsigned(118, 7) ) ELSE
                      coeffphase88_2 WHEN ( cur_count = to_unsigned(119, 7) ) ELSE
                      coeffphase120_2 WHEN ( cur_count = to_unsigned(120, 7) ) ELSE
                      coeffphase27_2 WHEN ( cur_count = to_unsigned(121, 7) ) ELSE
                      coeffphase59_2 WHEN ( cur_count = to_unsigned(122, 7) ) ELSE
                      coeffphase91_2 WHEN ( cur_count = to_unsigned(123, 7) ) ELSE
                      coeffphase123_2 WHEN ( cur_count = to_unsigned(124, 7) ) ELSE
                      coeffphase30_2 WHEN ( cur_count = to_unsigned(125, 7) ) ELSE
                      coeffphase62_2 WHEN ( cur_count = to_unsigned(126, 7) ) ELSE
                      coeffphase94_2;
  product <= delay_pipeline(1) * product_mux;

  product_mux_1 <= coeffphase1_1 WHEN ( cur_count = to_unsigned(1, 7) ) ELSE
                        coeffphase33_1 WHEN ( cur_count = to_unsigned(2, 7) ) ELSE
                        coeffphase65_1 WHEN ( cur_count = to_unsigned(3, 7) ) ELSE
                        coeffphase97_1 WHEN ( cur_count = to_unsigned(4, 7) ) ELSE
                        coeffphase4_1 WHEN ( cur_count = to_unsigned(5, 7) ) ELSE
                        coeffphase36_1 WHEN ( cur_count = to_unsigned(6, 7) ) ELSE
                        coeffphase68_1 WHEN ( cur_count = to_unsigned(7, 7) ) ELSE
                        coeffphase100_1 WHEN ( cur_count = to_unsigned(8, 7) ) ELSE
                        coeffphase7_1 WHEN ( cur_count = to_unsigned(9, 7) ) ELSE
                        coeffphase39_1 WHEN ( cur_count = to_unsigned(10, 7) ) ELSE
                        coeffphase71_1 WHEN ( cur_count = to_unsigned(11, 7) ) ELSE
                        coeffphase103_1 WHEN ( cur_count = to_unsigned(12, 7) ) ELSE
                        coeffphase10_1 WHEN ( cur_count = to_unsigned(13, 7) ) ELSE
                        coeffphase42_1 WHEN ( cur_count = to_unsigned(14, 7) ) ELSE
                        coeffphase74_1 WHEN ( cur_count = to_unsigned(15, 7) ) ELSE
                        coeffphase106_1 WHEN ( cur_count = to_unsigned(16, 7) ) ELSE
                        coeffphase13_1 WHEN ( cur_count = to_unsigned(17, 7) ) ELSE
                        coeffphase45_1 WHEN ( cur_count = to_unsigned(18, 7) ) ELSE
                        coeffphase77_1 WHEN ( cur_count = to_unsigned(19, 7) ) ELSE
                        coeffphase109_1 WHEN ( cur_count = to_unsigned(20, 7) ) ELSE
                        coeffphase16_1 WHEN ( cur_count = to_unsigned(21, 7) ) ELSE
                        coeffphase48_1 WHEN ( cur_count = to_unsigned(22, 7) ) ELSE
                        coeffphase80_1 WHEN ( cur_count = to_unsigned(23, 7) ) ELSE
                        coeffphase112_1 WHEN ( cur_count = to_unsigned(24, 7) ) ELSE
                        coeffphase19_1 WHEN ( cur_count = to_unsigned(25, 7) ) ELSE
                        coeffphase51_1 WHEN ( cur_count = to_unsigned(26, 7) ) ELSE
                        coeffphase83_1 WHEN ( cur_count = to_unsigned(27, 7) ) ELSE
                        coeffphase115_1 WHEN ( cur_count = to_unsigned(28, 7) ) ELSE
                        coeffphase22_1 WHEN ( cur_count = to_unsigned(29, 7) ) ELSE
                        coeffphase54_1 WHEN ( cur_count = to_unsigned(30, 7) ) ELSE
                        coeffphase86_1 WHEN ( cur_count = to_unsigned(31, 7) ) ELSE
                        coeffphase118_1 WHEN ( cur_count = to_unsigned(32, 7) ) ELSE
                        coeffphase25_1 WHEN ( cur_count = to_unsigned(33, 7) ) ELSE
                        coeffphase57_1 WHEN ( cur_count = to_unsigned(34, 7) ) ELSE
                        coeffphase89_1 WHEN ( cur_count = to_unsigned(35, 7) ) ELSE
                        coeffphase121_1 WHEN ( cur_count = to_unsigned(36, 7) ) ELSE
                        coeffphase28_1 WHEN ( cur_count = to_unsigned(37, 7) ) ELSE
                        coeffphase60_1 WHEN ( cur_count = to_unsigned(38, 7) ) ELSE
                        coeffphase92_1 WHEN ( cur_count = to_unsigned(39, 7) ) ELSE
                        coeffphase124_1 WHEN ( cur_count = to_unsigned(40, 7) ) ELSE
                        coeffphase31_1 WHEN ( cur_count = to_unsigned(41, 7) ) ELSE
                        coeffphase63_1 WHEN ( cur_count = to_unsigned(42, 7) ) ELSE
                        coeffphase95_1 WHEN ( cur_count = to_unsigned(43, 7) ) ELSE
                        coeffphase2_1 WHEN ( cur_count = to_unsigned(45, 7) ) ELSE
                        coeffphase34_1 WHEN ( cur_count = to_unsigned(46, 7) ) ELSE
                        coeffphase66_1 WHEN ( cur_count = to_unsigned(47, 7) ) ELSE
                        coeffphase98_1 WHEN ( cur_count = to_unsigned(48, 7) ) ELSE
                        coeffphase5_1 WHEN ( cur_count = to_unsigned(49, 7) ) ELSE
                        coeffphase37_1 WHEN ( cur_count = to_unsigned(50, 7) ) ELSE
                        coeffphase69_1 WHEN ( cur_count = to_unsigned(51, 7) ) ELSE
                        coeffphase101_1 WHEN ( cur_count = to_unsigned(52, 7) ) ELSE
                        coeffphase8_1 WHEN ( cur_count = to_unsigned(53, 7) ) ELSE
                        coeffphase40_1 WHEN ( cur_count = to_unsigned(54, 7) ) ELSE
                        coeffphase72_1 WHEN ( cur_count = to_unsigned(55, 7) ) ELSE
                        coeffphase104_1 WHEN ( cur_count = to_unsigned(56, 7) ) ELSE
                        coeffphase11_1 WHEN ( cur_count = to_unsigned(57, 7) ) ELSE
                        coeffphase43_1 WHEN ( cur_count = to_unsigned(58, 7) ) ELSE
                        coeffphase75_1 WHEN ( cur_count = to_unsigned(59, 7) ) ELSE
                        coeffphase107_1 WHEN ( cur_count = to_unsigned(60, 7) ) ELSE
                        coeffphase14_1 WHEN ( cur_count = to_unsigned(61, 7) ) ELSE
                        coeffphase46_1 WHEN ( cur_count = to_unsigned(62, 7) ) ELSE
                        coeffphase78_1 WHEN ( cur_count = to_unsigned(63, 7) ) ELSE
                        coeffphase110_1 WHEN ( cur_count = to_unsigned(64, 7) ) ELSE
                        coeffphase17_1 WHEN ( cur_count = to_unsigned(65, 7) ) ELSE
                        coeffphase49_1 WHEN ( cur_count = to_unsigned(66, 7) ) ELSE
                        coeffphase81_1 WHEN ( cur_count = to_unsigned(67, 7) ) ELSE
                        coeffphase113_1 WHEN ( cur_count = to_unsigned(68, 7) ) ELSE
                        coeffphase20_1 WHEN ( cur_count = to_unsigned(69, 7) ) ELSE
                        coeffphase52_1 WHEN ( cur_count = to_unsigned(70, 7) ) ELSE
                        coeffphase84_1 WHEN ( cur_count = to_unsigned(71, 7) ) ELSE
                        coeffphase116_1 WHEN ( cur_count = to_unsigned(72, 7) ) ELSE
                        coeffphase23_1 WHEN ( cur_count = to_unsigned(73, 7) ) ELSE
                        coeffphase55_1 WHEN ( cur_count = to_unsigned(74, 7) ) ELSE
                        coeffphase87_1 WHEN ( cur_count = to_unsigned(75, 7) ) ELSE
                        coeffphase119_1 WHEN ( cur_count = to_unsigned(76, 7) ) ELSE
                        coeffphase26_1 WHEN ( cur_count = to_unsigned(77, 7) ) ELSE
                        coeffphase58_1 WHEN ( cur_count = to_unsigned(78, 7) ) ELSE
                        coeffphase90_1 WHEN ( cur_count = to_unsigned(79, 7) ) ELSE
                        coeffphase122_1 WHEN ( cur_count = to_unsigned(80, 7) ) ELSE
                        coeffphase29_1 WHEN ( cur_count = to_unsigned(81, 7) ) ELSE
                        coeffphase61_1 WHEN ( cur_count = to_unsigned(82, 7) ) ELSE
                        coeffphase93_1 WHEN ( cur_count = to_unsigned(83, 7) ) ELSE
                        coeffphase125_1 WHEN ( cur_count = to_unsigned(84, 7) ) ELSE
                        coeffphase32_1 WHEN ( cur_count = to_unsigned(85, 7) ) ELSE
                        coeffphase64_1 WHEN ( cur_count = to_unsigned(86, 7) ) ELSE
                        coeffphase96_1 WHEN ( cur_count = to_unsigned(87, 7) ) ELSE
                        coeffphase3_1 WHEN ( cur_count = to_unsigned(89, 7) ) ELSE
                        coeffphase35_1 WHEN ( cur_count = to_unsigned(90, 7) ) ELSE
                        coeffphase67_1 WHEN ( cur_count = to_unsigned(91, 7) ) ELSE
                        coeffphase99_1 WHEN ( cur_count = to_unsigned(92, 7) ) ELSE
                        coeffphase6_1 WHEN ( cur_count = to_unsigned(93, 7) ) ELSE
                        coeffphase38_1 WHEN ( cur_count = to_unsigned(94, 7) ) ELSE
                        coeffphase70_1 WHEN ( cur_count = to_unsigned(95, 7) ) ELSE
                        coeffphase102_1 WHEN ( cur_count = to_unsigned(96, 7) ) ELSE
                        coeffphase9_1 WHEN ( cur_count = to_unsigned(97, 7) ) ELSE
                        coeffphase41_1 WHEN ( cur_count = to_unsigned(98, 7) ) ELSE
                        coeffphase73_1 WHEN ( cur_count = to_unsigned(99, 7) ) ELSE
                        coeffphase105_1 WHEN ( cur_count = to_unsigned(100, 7) ) ELSE
                        coeffphase12_1 WHEN ( cur_count = to_unsigned(101, 7) ) ELSE
                        coeffphase44_1 WHEN ( cur_count = to_unsigned(102, 7) ) ELSE
                        coeffphase76_1 WHEN ( cur_count = to_unsigned(103, 7) ) ELSE
                        coeffphase108_1 WHEN ( cur_count = to_unsigned(104, 7) ) ELSE
                        coeffphase15_1 WHEN ( cur_count = to_unsigned(105, 7) ) ELSE
                        coeffphase47_1 WHEN ( cur_count = to_unsigned(106, 7) ) ELSE
                        coeffphase79_1 WHEN ( cur_count = to_unsigned(107, 7) ) ELSE
                        coeffphase111_1 WHEN ( cur_count = to_unsigned(108, 7) ) ELSE
                        coeffphase18_1 WHEN ( cur_count = to_unsigned(109, 7) ) ELSE
                        coeffphase50_1 WHEN ( cur_count = to_unsigned(110, 7) ) ELSE
                        coeffphase82_1 WHEN ( cur_count = to_unsigned(111, 7) ) ELSE
                        coeffphase114_1 WHEN ( cur_count = to_unsigned(112, 7) ) ELSE
                        coeffphase21_1 WHEN ( cur_count = to_unsigned(113, 7) ) ELSE
                        coeffphase53_1 WHEN ( cur_count = to_unsigned(114, 7) ) ELSE
                        coeffphase85_1 WHEN ( cur_count = to_unsigned(115, 7) ) ELSE
                        coeffphase117_1 WHEN ( cur_count = to_unsigned(116, 7) ) ELSE
                        coeffphase24_1 WHEN ( cur_count = to_unsigned(117, 7) ) ELSE
                        coeffphase56_1 WHEN ( cur_count = to_unsigned(118, 7) ) ELSE
                        coeffphase88_1 WHEN ( cur_count = to_unsigned(119, 7) ) ELSE
                        coeffphase120_1 WHEN ( cur_count = to_unsigned(120, 7) ) ELSE
                        coeffphase27_1 WHEN ( cur_count = to_unsigned(121, 7) ) ELSE
                        coeffphase59_1 WHEN ( cur_count = to_unsigned(122, 7) ) ELSE
                        coeffphase91_1 WHEN ( cur_count = to_unsigned(123, 7) ) ELSE
                        coeffphase123_1 WHEN ( cur_count = to_unsigned(124, 7) ) ELSE
                        coeffphase30_1 WHEN ( cur_count = to_unsigned(125, 7) ) ELSE
                        coeffphase62_1 WHEN ( cur_count = to_unsigned(126, 7) ) ELSE
                        coeffphase94_1;
  product_1 <= delay_pipeline(0) * product_mux_1;

  product_1_cast <= resize(product_1, 33);

  add_temp <= resize(product_1_cast, 34) + resize(product, 34);
  fir_sum <= add_temp(32 DOWNTO 0);

  output_typeconvert <= fir_sum;

  Output_Register_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      output_register <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF phase_1 = '1' THEN
        output_register <= output_typeconvert;
      END IF;
    END IF; 
  END PROCESS Output_Register_process;

  -- Assignment Statements
  ce_out <= ce_out_phase;
  ce_in <= ce_in_reg;
  filter_out <= std_logic_vector(output_register);
END rtl;
